import type { Either } from '@lokalise/node-core';
import type { ExistingQueueOptions, MessageInvalidFormatError, MessageValidationError, MonoSchemaQueueOptions, NewQueueOptions, SyncPublisher } from '@message-queue-toolkit/core';
import type { ZodSchema } from 'zod';
import type { AMQPLocatorType } from './AbstractAmqpConsumer';
import { AbstractAmqpService } from './AbstractAmqpService';
import type { AMQPDependencies, CreateAMQPQueueOptions } from './AbstractAmqpService';
export declare abstract class AbstractAmqpPublisher<MessagePayloadType extends object> extends AbstractAmqpService<MessagePayloadType> implements SyncPublisher<MessagePayloadType> {
    private readonly messageSchema;
    constructor(dependencies: AMQPDependencies, options: (NewQueueOptions<CreateAMQPQueueOptions> | ExistingQueueOptions<AMQPLocatorType>) & MonoSchemaQueueOptions<MessagePayloadType>);
    publish(message: MessagePayloadType): void;
    protected resolveMessage(): Either<MessageInvalidFormatError | MessageValidationError, unknown>;
    protected resolveSchema(): Either<Error, ZodSchema<MessagePayloadType>>;
}
