import type { QueueConsumerDependencies, QueueDependencies, NewQueueOptions, ExistingQueueOptions } from '@message-queue-toolkit/core';
import { AbstractQueueService } from '@message-queue-toolkit/core';
import type { Channel, Connection, Message } from 'amqplib';
import type { Options } from 'amqplib/properties';
import type { AMQPLocatorType } from './AbstractAmqpConsumer';
export type AMQPDependencies = QueueDependencies & {
    amqpConnection: Connection;
};
export type AMQPConsumerDependencies = AMQPDependencies & QueueConsumerDependencies;
export type AMQPQueueConfig = Options.AssertQueue;
export type CreateAMQPQueueOptions = {
    queueOptions: AMQPQueueConfig;
    queueName: string;
};
export type AMQPQueueLocatorType = {
    queueName: string;
};
export declare abstract class AbstractAmqpService<MessagePayloadType extends object, DependenciesType extends AMQPDependencies = AMQPDependencies> extends AbstractQueueService<MessagePayloadType, Message, DependenciesType, CreateAMQPQueueOptions, AMQPQueueLocatorType, NewQueueOptions<CreateAMQPQueueOptions> | ExistingQueueOptions<AMQPLocatorType>> {
    protected readonly connection: Connection;
    protected channel: Channel;
    private isShuttingDown;
    protected readonly queueName: string;
    constructor(dependencies: DependenciesType, options: NewQueueOptions<CreateAMQPQueueOptions> | ExistingQueueOptions<AMQPLocatorType>);
    private destroyConnection;
    init(): Promise<void>;
    close(): Promise<void>;
}
